/* START globals and pre body load actions for text resize and preferences */

var fontSizes = new Array();
fontSizes[0] = "0.85em";
fontSizes[1] = "0.95em";
fontSizes[2] = "1.0em";
fontSizes[3] = "1.1em";
fontSizes[4] = "1.2em";

var themeNormal='normal';
var themeContrast='contrast';
var themeNone='none';

var searchAskUs='askus';
var searchCourses='courses';
var searchStaff='staff';
var searchWebsite='website';

var savedFontSize = $.cookie('curFontSize');
var savedTheme = $.cookie('curTheme');
var savedSearch = $.cookie('curSearch');
var savedFontIndex = null;

if(savedFontSize==null){
	setFontSize(fontSizes[2]);
	savedFontIndex = 2;
}else{
	setFontSize(savedFontSize);
	savedFontIndex = getIndex(fontSizes, savedFontSize);
}

if(savedTheme==null){
	savedTheme = themeNormal;
	setTheme(themeNormal);
}else{
	setTheme(savedTheme);
}

if(savedSearch==null){
	savedSearch = searchWebsite;
}


function setFontSize(selectedSize){
	$('html').css('font-size', selectedSize);
	// Only save cookie with 30 day expiry when preferences are saved
	// See save click function later on
	$.cookie('curFontSize', selectedSize, { path: '/', domain: 'ecu.edu.au' });
	savedFontSize = $.cookie('curFontSize');
}

function setSearch(selectedSearch){
        $("#cse-search-box input#tab").val(selectedSearch);
}

function setTheme(selectedTheme){
	switch(selectedTheme){
		case themeNormal:
			$("link#h-contrast").attr('disabled', true); /*safari fix*/
			$("link#h-contrast").remove();
			$("link[rel*='stylesheet']").each(function(i){
				this.disabled = false;
			});
			break;
		case themeContrast:
			$("link[rel*='stylesheet']").each(function(i){
				this.disabled = false;
			});
			var contStyleSource = "./?a=1813";
			$("head").append('<link id="h-contrast" rel="stylesheet" type="text/css" href='+'"'+contStyleSource+'"'+' media="all" />');
			break;
		case themeNone:
			$("link[rel*='stylesheet']").each(function(i){
				this.disabled = true;
			});
			$("link#h-contrast").remove();
			break;
	}
}

function changeFontSize(direction){
	var fontIndex = getIndex(fontSizes, savedFontSize);
	var fontArrayLength = fontSizes.length;
	if((direction=="up") && (fontIndex < fontArrayLength)){
		fontIndex++;
	}
	if((direction=="down") && (fontIndex > 0)){
		fontIndex--;
	}
	setFontSize(fontSizes[fontIndex]);
	$("#website-preferences input:radio[value='"+fontIndex+"']").attr('checked', true);
}

/* END globals and pre body load actions for text resize and preferences */


/* START jquery doc ready function for text resize and setting preferences. */

$(document).ready(function() {
	
	setSearch(savedSearch);

	/* pre check the preference page form radio buttons using saved values */
	$("#website-preferences input:radio[value='"+savedFontIndex+"']").attr('checked', true);
	$("#website-preferences input:radio[value='"+savedTheme+"']").attr('checked', true);
	$("#website-preferences input:radio[value='"+savedSearch+"']").attr('checked', true);

	$(".decrease-font-size").click(function(event){
		changeFontSize("down");
		event.preventDefault();
	});
	
	$(".increase-font-size").click(function(event){
		changeFontSize("up");
		event.preventDefault();
	});
				   
	$("input[name='pref-text-size']").click(function(){
		var checkedValue = $("input[name='pref-text-size']:checked").val() + "";
		if (checkedValue){
			setFontSize(fontSizes[checkedValue]);
		}
	});
	
	$("input[name='pref-style']").click(function(){
		var checkedValue = $("input[name='pref-style']:checked").val() + "";
		if (checkedValue){
			displayRadioCheckedTheme(checkedValue);
		}
	});
	
	$("input[name='pref-search']").click(function(){
		var checkedValue = $("input[name='pref-search']:checked").val() + "";
		if (checkedValue){
			setSearch(checkedValue);
		}
	});
	
	$("#website-preferences input:radio").click(function(){
		$("#saved-success").removeClass("show");
	});
	
	function displayRadioCheckedTheme(checkedValue){
		var docLocation = document.location.href;
		switch(checkedValue){
			case 'normal':
				$("body").fadeOut(1000, function () {
					setTheme(themeNormal);
					docLocation = removeAnchors(docLocation);
					document.location.href = docLocation + '#top-page';
				});
				$("body").fadeIn(1000);
				break;
			case 'contrast':
				$("body").fadeOut(1000, function () {
					setTheme(themeContrast);
					docLocation = removeAnchors(docLocation);
					document.location.href = docLocation + '#top-page';
				});
				$("body").fadeIn(1000);
				break;
			case 'none':
				$("body").fadeOut(1000, function () {
					setTheme(themeNone);
					docLocation = removeAnchors(docLocation);			
					document.location.href = docLocation + '#change-website-preferences';
					$("#save-preferences span").css('visibility','hidden');
				});
				$("body").fadeIn(1000);
				break;
		}
	}
	
	// Clean up URL anchors
	function removeAnchors(varURL){
		varURL = removeTokenFromString(varURL,'#top-page');
		varURL = removeTokenFromString(varURL,'#change-website-preferences');
		return varURL;
	}
	
	
	// Save selected preferences
	$("#website-preferences #save-button").click(function(event){
																			
		if($("input[name='pref-style']:checked").val()==themeNone){
			$("#save-preferences span").css('visibility','hidden');
		}else{
			$("#save-preferences span").css('visibility','visible');
		}
		
		var curRadioTheme = $("input[name='pref-style']:checked").val() + "";
		$.cookie('curTheme', curRadioTheme, { expires: 30, path: '/', domain: 'ecu.edu.au' });
		savedTheme = $.cookie('curTheme');
		
		var curRadioSearch = $("input[name='pref-search']:checked").val() + "";
		$.cookie('curSearch', curRadioSearch, { expires: 30, path: '/', domain: 'ecu.edu.au'});
		savedSearch = $.cookie('curSearch');
		
		$.cookie('curFontSize', savedFontSize, { expires: 30, path: '/', domain: 'ecu.edu.au' });
		
		$("#website-preferences input:radio").attr('disabled', true);
		$("#website-preferences #save-button").attr('disabled', true);	
		$("#saved-success").removeClass("show");
		$("#saved-feedback").addClass("show");
		
		$("#saved-feedback img").fadeOut(0).fadeIn(4000, function () {																			  
			$("#saved-feedback").removeClass("show");
			$("#saved-success").addClass("show").fadeOut(0).fadeIn(1000);
			$("#website-preferences input:radio").attr('disabled', false);
			$("#website-preferences #save-button").attr('disabled', false);		
		});
		
	});
	
});

/* END jquery doc ready function for text resize and setting preferences. */